//-----------------------------------------------------------------------------
// Weapon_RevolversDuo
// SolarFlare
//-----------------------------------------------------------------------------

datablock DecalData(RevolverDuoIcon)
{
   textureName = "./Icon_revolversDuo";
};   

datablock DecalData(RevolverDuoCI)
{
   textureName = "./CI_revolversDuo";
};   

AddDamageType("DuoRevolver", '<bitmap:add-ons/Weapon_RevolversDuo/CI_revolversDuo> %1', '%2 <bitmap:add-ons/Weapon_RevolversDuo/CI_revolversDuo> %1', 0.05, 1);

datablock ProjectileData(duoRevolverProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::DuoRevolver;
   radiusDamageType    = $DamageType::DuoRevolver;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = sfRevolverExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 120;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Duo Revolver Bullet";
};

//-----------------------------------------------------------------------------
// Item

datablock ItemData(duoRevolverItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "Add-Ons/Weapon_SFRevolver/sfrevolver_3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Revolvers Duo";
	iconName = "./icon_revolversDuo";

	 // Dynamic properties defined by the scripts
	image = duoRevolverImage;
	canDrop = true;
};

//-----------------------------------------------------------------------------
// Image

datablock ShapeBaseImageData(duoRevolverImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_SFRevolver/sfrevolver_3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DuoRevolverProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "PreAmmoCheck";
	stateSequence[0]	         = "draw";
	stateSound[0]			 = sfRevolverDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
   stateTransitionOnNoAmmo[1] = "AmmoCheck";
	stateAllowImageChange[1]         = true;

	stateName[2]                     = "Fire";
	stateTransitionOnTimeout[2]      = "Smoke";
   stateSequence[2]                 = "spin";
	stateTimeoutValue[2]             = 0.14;
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateScript[2]                   = "onFire";
	stateWaitForTimeout[2]		 = true;
	stateEmitter[2]			 = sfRevolverFlashEmitter;
	stateEmitterTime[2]		 = 0.06;
	stateEmitterNode[2]		 = "muzzleNode";
	stateSound[2]			 = sfRevolverShotSound;
   
   stateName[3]                     = "Smoke";
	stateSequence[3]                 = "spin";
	stateEmitter[3]			 = sfRevolverSmokeEmitter;
	stateEmitterTime[3]		 = 0.05;
	stateEmitterNode[3]		 = "muzzleNode";
	stateTimeoutValue[3]             = 0.5;
   stateScript[3] = "onFireDuo";
	stateTransitionOnTimeout[3]      = "AmmoCheck";
   
   stateName[4]			 = "PreReload";
   stateWaitForTimeout[4]		 = true;
	stateTransitionOnTimeout[4]      = "Reload";
	stateTimeoutValue[4]             = 0.2;

	stateName[5]			 = "Reload";
	stateSequence[5]                 = "open";
   stateWaitForTimeout[5]		 = true;
	stateTransitionOnTimeout[5]      = "Reload_2";
	stateTimeoutValue[5]             = 1.25;
   stateSound[5]			 = sfRevolverReloadSound;
   
   stateName[6]			 = "Reload_2";
   stateWaitForTimeout[6]		 = true;
	stateTransitionOnTimeout[6]      = "Reload_3";
	stateTimeoutValue[6]             = 0.4;
   
   stateName[7]			 = "Reload_3";
	stateSequence[7]                 = "spin";
   stateWaitForTimeout[7]		 = true;
	stateTransitionOnTimeout[7]      = "Ready";
	stateTimeoutValue[7]             = 0.4;
   stateSound[7]			 = sfRevolverSpinSound;
   stateScript[7]			 = "onReload";
   
   stateName[8]                     = "PreAmmoCheck";
	stateTransitionOnTimeout[8]      = "AmmoCheck";
	stateTimeoutValue[8]             = 0;
	stateAllowImageChange[8]         = true;
   stateScript[8]         = "onAmmoCheck";
   
   stateName[9]                     = "AmmoCheck";
   stateTransitionOnAmmo[9] = "Ready";
   stateTransitionOnNoAmmo[9] = "PreReload";
	stateAllowImageChange[9]         = true;
};

datablock ShapeBaseImageData(leftHandedRevolverImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_SFRevolver/sfrevolver_3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DuoRevolverProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "PreAmmoCheck";
	stateSequence[0]	         = "draw";
	//stateSound[0]			 = sfRevolverDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
   stateTransitionOnNoAmmo[1] = "AmmoCheck";
	stateAllowImageChange[1]         = true;

	stateName[2]                     = "Fire";
	stateTransitionOnTimeout[2]      = "Smoke";
   stateSequence[2]                 = "spin";
	stateTimeoutValue[2]             = 0.14;
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateScript[2]                   = "onFire";
	stateWaitForTimeout[2]		 = true;
	stateEmitter[2]			 = sfRevolverFlashEmitter;
	stateEmitterTime[2]		 = 0.06;
	stateEmitterNode[2]		 = "muzzleNode";
	stateSound[2]			 = sfRevolverShotSound;
   
   stateName[3]                     = "Smoke";
	stateSequence[3]                 = "spin";
	stateEmitter[3]			 = sfRevolverSmokeEmitter;
	stateEmitterTime[3]		 = 0.05;
	stateEmitterNode[3]		 = "muzzleNode";
	stateTimeoutValue[3]             = 0.5;
	stateTransitionOnTimeout[3]      = "AmmoCheck";
   
   stateName[4]			 = "PreReload";
   stateWaitForTimeout[4]		 = true;
	stateTransitionOnTimeout[4]      = "Reload";
	stateTimeoutValue[4]             = 0.2;

	stateName[5]			 = "Reload";
	stateSequence[5]                 = "open";
   stateWaitForTimeout[5]		 = true;
	stateTransitionOnTimeout[5]      = "Reload_2";
	stateTimeoutValue[5]             = 1.25;
   //stateSound[5]			 = sfRevolverReloadSound;
   
   stateName[6]			 = "Reload_2";
   stateWaitForTimeout[6]		 = true;
	stateTransitionOnTimeout[6]      = "Reload_3";
	stateTimeoutValue[6]             = 0.4;
   
   stateName[7]			 = "Reload_3";
	stateSequence[7]                 = "spin";
   stateWaitForTimeout[7]		 = true;
	stateTransitionOnTimeout[7]      = "Ready";
	stateTimeoutValue[7]             = 0.4;
   //stateSound[7]			 = sfRevolverSpinSound;
   stateScript[7]			 = "onReload";
   
   stateName[8]                     = "PreAmmoCheck";
	stateTransitionOnTimeout[8]      = "AmmoCheck";
	stateTimeoutValue[8]             = 0;
	stateAllowImageChange[8]         = true;
   stateScript[8]         = "onAmmoCheck";
   
   stateName[9]                     = "AmmoCheck";
   stateTransitionOnAmmo[9] = "Ready";
   stateTransitionOnNoAmmo[9] = "PreReload";
	stateAllowImageChange[9]         = true;
};

//-----------------------------------------------------------------------------
// Script

function leftHandedRevolverImage::onFire(%this, %obj, %slot)
{
   %obj.duoRevolverAmmo -= 1;
   if(%obj.duoRevolverAmmo < 1)
   {
      %obj.setImageAmmo(%slot, 0);
      %obj.setImageAmmo(0, 0);
   }
   
   if((%obj.lastFireTime + %this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
   
   if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, leftrecoil);
   parent::onFire(%this, %obj, %slot);
}

function duoRevolverImage::onMount(%this, %obj, %slot)
{
   parent::onMount(%this, %obj, %slot);
   %obj.mountImage(leftHandedRevolverImage, 1);
}

function duoRevolverImage::onUnMount(%this, %obj, %slot)
{
   parent::onUnMount(%this, %obj, %slot);
   %obj.unMountImage(1);
}

function leftHandedRevolverImage::onMount(%this, %obj, %slot)
{
   parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}

function leftHandedRevolverImage::onUnMount(%this, %obj, %slot)
{
   parent::onUnMount(%this, %obj, %slot);
}

function duoRevolverImage::onFire(%this, %obj, %slot)
{
   %obj.duoRevolverAmmo -= 1;
   if(%obj.duoRevolverAmmo < 1)
   {
      %obj.setImageAmmo(%slot, 0);
      %obj.setImageAmmo(1, 0);
   }
   
   if((%obj.lastFireTime + %this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
   
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	parent::onFire(%this, %obj, %slot);	
}

function duoRevolverImage::onFireDuo(%this, %obj, %slot)
{   
   %obj.setImageTrigger(1, 1);
}

function leftHandedRevolverImage::onReload(%this, %obj, %slot)
{
   %obj.setImageAmmo(%slot, 1);
   %obj.setImageAmmo(0, 1);
   %obj.duoRevolverAmmo = 12;
}

function leftHandedRevolverImage::onAmmoCheck(%this, %obj, %slot)
{
   if(%obj.duoRevolverAmmo < 1)
   {
      %obj.setImageAmmo(%slot, 0);
      %obj.setImageAmmo(0, 0);
   }
}

package revolverDuoAlt
{
   function armor::onTrigger(%this, %player, %slot, %val)
   {
      if(%player.getMountedImage(0) $= duoRevolverImage.getID() && %slot $= 4 && %val && %player.duoRevolverAmmo < 12)
      {
         %player.duoRevolverAmmo = 12;
         %player.setImageAmmo(0, 0);
         %player.setImageAmmo(1, 0);
      }
      parent::onTrigger(%this, %player, %slot, %val);
   }
};   
activatePackage(revolverDuoAlt);

